<?php


class Image
{
var $GIF=IMG_GIF;

var $PNG=IMG_PNG;

var $JPG=IMG_JPG;

var $BMP=IMG_WBMP;


var $theimage=0;

var $font=1;

var $texture=0;

var $created=false;

var $width=0;

var $height=0;


function create($w,$h)
{
$this->theimage=imagecreate($w,$h);
$this->width=$w;
$this->height=$h;
$this->created=true;
return $this->theimage;
}

function notCreated()
{
echo "Runtime error: image not created", "\n";
return 0;
}

function copy($x,$y,$w,$h,$dst,$dx,$dy)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imagecopy($dst,$this->theimage,$dx,$dy,$x,$y,$w,$h));
}

function setFont($f){
$this->font=$f;
return;
}

function setTexture($t){
$this->texture=$t;
return;
}

function update()
{
$this->width=intVal(imagesx($this->theimage));
$this->height=intVal(imagesy($this->theimage));
return;
}

function createColor($r,$g,$b)
{
if(!$this->created) {
return $this->notCreated();}

return intVal(imagecolorallocate($this->theimage,$r,$g,$b));
}
function ellipse($cx,$cy,$w,$h,$color)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imageellipse($this->theimage,$cx,$cy,$w,$h,$color));
}

function getPixel($x,$y)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imagecolorat($this->theimage,$x,$y));
}

function setPixel($x,$y,$color)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imagepixel($x,$y,$color));
}

function line($x,$y,$x2,$y2,$color)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imageline($this->theimage,$x,$y,$x2,$y2,$color));
}

function fill($color,$x=0,$y=0)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imagefill($this->theimage,$x,$y,$color));
}

function rectangle($xl,$yt,$xr,$yb,$color)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imagerectangle($this->theimage,$xl,$yt,$xr,$yb,$color));
}

function loadGif($filename)
{
$this->theimage=imagecreatefromgif($filename);
$this->created=$this->theimage!=0;
$this->update();
return $this->created;
}

function loadJpg($filename)
{
$this->theimage=imagecreatefromjpeg($filename);
$this->created=$this->theimage!=0;
$this->update();
return $this->created;
}

function loadPng($filename)
{
$this->theimage=imagecreatefrompng($filename);
$this->created=$this->theimage!=0;
$this->update();
return $this->created;
}

function loadBmp($filename)
{
$this->theimage=imagecreatefromwbmp($filename);
$this->created=$this->theimage!=0;
$this->update();
return $this->created;
}

function savePng($filename)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imagepng($this->theimage,$filename));
}

function saveJpeg($filename,$quality=80)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imagejpeg($this->theimage,$filename,$quality));
}

function saveJpg($filename,$quality=80)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imagejpeg($this->theimage,$filename,$quality));
}

function saveBmp($filename)
{
if(!$this->created) {
return $this->notCreated();
}
return intVal(imagewbmp($this->theimage));
}

function write($x,$y,$t,$color)
{
if(!$this->created) {
$this->notCreated();return;}
imagestring($this->theimage,$this->font,$x,$y,$t,$color);
return;
}

function support($type)
{


if($type===$this->GIF){

}else {
if($type===$this->JPG){
}else {
if($type===$this->PNG){
}else {
if($type===$this->BMP){
}else {
return false;
}}}}
return (imagetypes()&$type)!=0;
}
function dispSupport($format,$f)
{
echo $format," ";
if($this->support($f)) {
echo "supported", "\n";}
else {
echo "not supported", "\n";
}
return;
}

function checkSupport()
{
$this->dispSupport("GIF",$this->GIF);
$this->dispSupport("JPG",$this->JPG);
$this->dispSupport("PNG",$this->PNG);
$this->dispSupport("BMP",$this->BMP);
return;
}

}

?>
